#include <alloc.h>
#include "vesalib.h"
#include <dos.h>
#include <stdio.h>
#include <conio.h>
#include "vmouse.h"

#define FVERSION "2.1"
#define MAXMENUS 7
//MAXMENUS  䮭 :)

unsigned long **font;
int h, w;
int dx, dy, y_begin=15;
oBorder regions;
ObjectMouse mouse;
char fnt_file_name[256];
char *MenuCaptions[MAXMENUS];

void Init(void);
void DrawTable(bool _all, int __i, int __j);
void EditSymbol(int _symbol);
bool SaveData(void);
bool SaveSmosa(void);
bool SaveFont(char *_path);
bool LoadFont(char *_path);
void DrawSymbInfo(int x, int y, int _smb);

void Init(void)
{

CImage16x16 img;

int i, x, tw;

for (i=0; i<MAXMENUS; i++)

   MenuCaptions[i]="";

MenuCaptions[1]="室";

MenuCaptions[2]="࠭";

MenuCaptions[3]="MGIFONT";

MenuCaptions[4]="SMOSA";


regions.Set(0, 0, y_begin,

   (dx<<4)-1, (dy<<4)-1+y_begin);

settextstyle(0,0,1);

for (i=1; i<=4; i++)

{

   x = 20 + (i-1)*100;

   tw = textwidth(MenuCaptions[i]);

   regions.Set(i, x, 0, x+tw, y_begin-1);

}

img.fld[0] = 0xFCCC; img.fld[1] = 0xFCCC;

img.fld[2] = 0xFFF0; img.fld[3] = 0x0;
img.fld[4] = 0x0; img.fld[5] = 0x0;
img.fld[6] = 0x0; img.fld[7] = 0x0;
img.fld[8] = 0x0; img.fld[9] = 0x0;
img.fld[10] = 0x0; img.fld[11] = 0x0;
img.fld[12] = 0x0; img.fld[13] = 0x0;
img.fld[14] = 0x0; img.fld[15] = 0x0;
img.fld[16] = 0x0; img.fld[17] = 0xFF;
img.fld[18] = 0xFFFF; img.fld[19] = 0xFFFF;
img.fld[20] = 0xF000; img.fld[21] = 0x0;
img.fld[22] = 0xF000; img.fld[23] = 0xF000;
img.fld[24] = 0x0; img.fld[25] = 0xF000;
img.fld[26] = 0xF000; img.fld[27] = 0x0;
img.fld[28] = 0xF000; img.fld[29] = 0xF000;
img.fld[30] = 0x0; img.fld[31] = 0x0;
img.fld[32] = 0x0; img.fld[33] = 0x0;

img.fld[34] = 0xF00F; img.fld[35] = 0x8FFF;
img.fld[36] = 0xFFFF; img.fld[37] = 0xFFF8;
img.fld[38] = 0xF88F; img.fld[39] = 0xFFFF;
img.fld[40] = 0xFFF8; img.fld[41] = 0xF88F;
img.fld[42] = 0xFFFF; img.fld[43] = 0xFFF8;
img.fld[44] = 0xF88F; img.fld[45] = 0xFFFF;
img.fld[46] = 0xFFF0; img.fld[47] = 0x0;
img.fld[48] = 0x0; img.fld[49] = 0xFF;
img.fld[50] = 0xFFF; img.fld[51] = 0xFF88;
img.fld[52] = 0xFFFF; img.fld[53] = 0xFFFF;
img.fld[54] = 0xFFFF; img.fld[55] = 0xFFFF;
img.fld[56] = 0xFFFF; img.fld[57] = 0xFFFF;
img.fld[58] = 0xFFFF; img.fld[59] = 0xFFFF;
img.fld[60] = 0xFFFF; img.fld[61] = 0xFF;
img.fld[62] = 0x0; img.fld[63] = 0x0;
mouse.InstallCursor(img,0,0);


img.fld[0] = 0x80; img.fld[1] = 0x8870;

img.fld[2] = 0x8700; img.fld[3] = 0x7800;
img.fld[4] = 0x4000; img.fld[5] = 0x4000;
img.fld[6] = 0x0; img.fld[7] = 0x0;
img.fld[8] = 0x0; img.fld[9] = 0x0;
img.fld[10] = 0x0; img.fld[11] = 0x0;
img.fld[12] = 0x0; img.fld[13] = 0x0;
img.fld[14] = 0x0; img.fld[15] = 0x0;
img.fld[16] = 0x0; img.fld[17] = 0x0;
img.fld[18] = 0x8; img.fld[19] = 0x444;
img.fld[20] = 0x4444; img.fld[21] = 0x444C;
img.fld[22] = 0x4C44; img.fld[23] = 0x444C;
img.fld[24] = 0x4C40; img.fld[25] = 0xC400;
img.fld[26] = 0xC000; img.fld[27] = 0x0;
img.fld[28] = 0x0; img.fld[29] = 0x0;
img.fld[30] = 0x0; img.fld[31] = 0x0;
img.fld[32] = 0x0; img.fld[33] = 0x0;

img.fld[34] = 0x0; img.fld[35] = 0x0;
img.fld[36] = 0x0; img.fld[37] = 0x4;
img.fld[38] = 0x44; img.fld[39] = 0x444;
img.fld[40] = 0x4444; img.fld[41] = 0x4444;
img.fld[42] = 0x44C4; img.fld[43] = 0x444C;
img.fld[44] = 0x4CC4; img.fld[45] = 0x4440;
img.fld[46] = 0xCC00; img.fld[47] = 0x4000;
img.fld[48] = 0x0; img.fld[49] = 0x0;
img.fld[50] = 0x0; img.fld[51] = 0x0;
img.fld[52] = 0x0; img.fld[53] = 0x0;
img.fld[54] = 0x0; img.fld[55] = 0x0;
img.fld[56] = 0x0; img.fld[57] = 0x0;
img.fld[58] = 0x4; img.fld[59] = 0x44;
img.fld[60] = 0x444; img.fld[61] = 0x444;
img.fld[62] = 0x444; img.fld[63] = 0x4C;
mouse.InstallCursor(img,0,0);

}//end Init
//-----------------------------------------------------


void DrawTable(bool _all, int I, int J)
{

int xpos, ypos, ii, ji, sz;

int xgrid, ygrid, xm, ym;

unsigned char ch, *s="*";

char outBuf[20];

if (_all)

{

 installfont(1,font,h,w);

 setfillstyle(1,240);

 bar(regions.GetL(0), regions.GetT(0),

    regions.GetR(0), regions.GetB(0));

 setfillstyle(1,27);

 //Draw symbols

 for (ii=0; ii<16; ii++)

   for (ji=0; ji<16; ji++) DrawTable(false, ii, ji);

 //Draw grid lines

 xm=16*dx-1;

 ym=16*dy-1+y_begin;

 for (ii=0; ii<16; ii++)

 {

   xgrid=(ii+1)*dx-1;

   setfillstyle(1,56);

   bar(xgrid-2, y_begin, xgrid, ym);

 }//end for ii

 for (ji=0; ji<16; ji++)

 {

   ygrid=(ji+1)*dy-1+y_begin;

   if ((h>16) || (h<8))

   {

      setcolor(56);

      line(0, ygrid, xm, ygrid);

   }

   else

   {

      setfillstyle(1,56);

      bar(0, ygrid-(dy-h-1), xm, ygrid);

   }

 }//end for ii

 settextjustify(LEFT_TEXT, TOP_TEXT);

 settextstyle(0, 0, 1);

 setcolor(80);

 sz=regions.GetSize();

 for (ii=0; ii<sz; ii++)

   outtextxy(regions.GetL(ii), regions.GetT(ii),

      MenuCaptions[ii]);

 settextstyle(0, 0, 2);

 setcolor(55);

 outtextxy(50, 584, "FontEd "FVERSION);

 settextstyle(0, 0, 1);

 setcolor(15);

 outtextxy(5, 570, fnt_file_name);

 setcolor(28);

 sprintf(outBuf, "=%d", h);

 outtextxy(240, 572, outBuf);

 sprintf(outBuf, "=%d", w);

 outtextxy(240, 584, outBuf);

 setcolor(32);

 line(0, 568, 799, 568);

 line(0, 582, 230, 582);

 line(230, 568, 230, 599);

 line(295, 568, 295, 599);

}//end if

else

{

      xpos=dx*I; ypos=dy*J+y_begin;

      ch=(unsigned char)(I+(J<<4));

      s[0]=ch;

      settextjustify(LEFT_TEXT, TOP_TEXT);

      if ((I!=0) || (J!=0))

         setfillstyle(1,27);

      else

         setfillstyle(1,22);

      bar(xpos, ypos, xpos+w-1, ypos+h-1);

      settextstyle(1,0,1); setcolor(150);

      outtextxy(xpos,ypos,s);

      settextstyle(0,0,1); setcolor(45);

      outtextxy(xpos+w,ypos,s);

      //debug

      /*char debgS[256];

      sprintf(debgS, "%d", h);

      setfillstyle(1,0);

      bar(0, 0, 30, 10);

      settextstyle(0,0,1); setcolor(15);

      outtextxy(5,2,debgS);*/

}//end else

}//end DrawTable
//-----------------------------------------------------

void EditSymbol(int _symbol)
{

unsigned long **tempfont, mask;

oBorder areas;

int xx0, yy0, xx1, yy1, x, y;

int side=5, i, j;

unsigned char *tmps="*";

bool Looping=true, Ok=false;

int x1=50, y1=100, x2=700, y2=500;

unsigned long size;
void far *bitmap;

size=imagesizelong(x1,y1,x2,y2);

bitmap=farmalloc(size);

tempfont=new unsigned long* [256];

for (i=0; i<256; i++) tempfont[i]=new unsigned long [h];

//array created

for (i=0; i<h; i++) tempfont[_symbol][i]=font[_symbol][i];

installfont(2,tempfont,h,w);

getimage(x1,y1,x2,y2,bitmap);

setfillstyle(1,104);

bar(x1,y1,x2,y2);

setfillstyle(1,79);

bar(x1,y1,x2,y1+12);

settextstyle(0,0,1); setcolor(15);

outtextxy(x1+200,y1+2,"஢ ᨬ");

xx0=x1+200; yy0=y1+200;

areas.Set(0, xx0, yy0, xx0+side*w-1, yy0+side*h-1); //editor

xx1=x1+280; yy1=y1+100;

areas.Set(1, xx1, yy1, xx1+w-1, yy1+h-1); //viewer

areas.Set(2, x1+100, y1+20, x1+150, y1+40);

areas.Set(3, x2-150, y1+20, x2-120, y1+40);

//areas setted

setfillstyle(1,54);

bar(xx0,yy0,areas.GetR(0),areas.GetB(0)); //edit area background

settextstyle(1,0,side); setcolor(22);

tmps[0]=(unsigned char)_symbol;

outtextxy(xx0,yy0,tmps); //symbol in edit area

settextstyle(0,0,2); setcolor(85);

outtextxy(xx0-50,yy0,tmps); //symbol in standard font

for (i=0; i<=16; i+=2)

{

   setcolor(102);

   if (i%4==0) setcolor(64);

   if (i%8==0) setcolor(47);

   line(xx0-50+i, yy0-1, xx0-50+i, yy0-3);

   line(xx0-50+i, yy0+16, xx0-50+i, yy0+19);

}

for (i=0; i<=16; i+=2)

{

   setcolor(102);

   if (i%4==0) setcolor(64);

   if (i%8==0) setcolor(47);

   line(xx0-51, yy0+i, xx0-53, yy0+i);

   line(xx0-34, yy0+i, xx0-32, yy0+i);

}

for (i=0; i<=w; i++)

{

   setcolor(102);

   if (i%4==0) setcolor(64);

   if (i%8==0) setcolor(47);

   line(xx0+side*i, yy0, xx0+side*i, areas.GetB(0));

}

for (j=0; j<=h; j++)

{

   setcolor(102);

   if (j%4==0) setcolor(64);

   if (j%8==0) setcolor(47);

   line(xx0, yy0+side*j, areas.GetR(0), yy0+side*j);

}

settextstyle(0,0,1);

setcolor(85);

outtextxy(areas.GetL(0),areas.GetT(0)-20," ।");

//edit area

rectangle(xx1-1,yy1-1,areas.GetR(1)+1,areas.GetB(1)+1);

setcolor(102);

outtextxy(areas.GetL(1),areas.GetT(1)-20," ᬮ"); //view area

setcolor(42);

outtextxy(areas.GetL(2),areas.GetT(2),"⬥");

setcolor(95);

outtextxy(areas.GetL(3),areas.GetT(3),"!");

mouse.SetCursor(1);

while (Looping)

{

   setfillstyle(1,0);

   bar(areas.GetL(1),areas.GetT(1),areas.GetR(1),areas.GetB(1));

   settextstyle(2,0,1); setcolor(80);

   tmps[0]=(unsigned char)_symbol;

   outtextxy(areas.GetL(1),areas.GetT(1),tmps);

   do

   {

      mouse.Show();

      delay(50);

      mouse.Ask();

      mouse.Hide();

   }

   while ( ! (mouse.Left() || mouse.Right()) );

   switch (mouse.Find(&areas))

   {

      case 0: i=(mouse.X()-xx0)/side;

              j=(mouse.Y()-yy0)/side;

              mask=1L<<i;

              if (mouse.Left())

              {

               setfillstyle(1,22);

               tempfont[_symbol][j]=tempfont[_symbol][j] | mask;

              }

              else

              {

               setfillstyle(1,54);

               tempfont[_symbol][j]=tempfont[_symbol][j] & (~mask);

              }

              x=xx0+side*i;

              y=yy0+side*j;

              bar(x+1,y+1,x+side-1,y+side-1);

              break;

      case 3: Ok=true;

      case 2: Looping=false;

              while ( ! (mouse.LClick() || mouse.RClick()) )

                  mouse.Ask();

              break;

   }//end switch

}//end while

if (Ok)

   for (i=0; i<h; i++) font[_symbol][i]=tempfont[_symbol][i];

mouse.SetCursor(0);

putimage(x1,y1,bitmap,0);

for (i=0; i<256; i++) delete[] tempfont[i];

delete[] tempfont;

farfree(bitmap);

}//end EditSymbol
//-----------------------------------------------------

bool SaveData(void)
{

FILE *out2;

bool Good;

int i, j;

char *datafile="*********************************";

char *variable="*********************************";

textcolor(10);

cprintf("  䠩   : ");

scanf("%s",datafile);

cprintf("  ६ ⨯ MGIFONT \n\r");

scanf("%s",variable);

out2=fopen(datafile,"wt");

Good=(out2!=NULL);

if (Good)

{

   for (i=0; i<256; i++)

      for (j=0; j<h; j++) fprintf(out2,"%s[%d][%d]=0x%lXL;\n\r",

                                  variable,i,j,font[i][j]);

   fclose(out2);

}//end if

return Good;

}//end SaveData
//-----------------------------------------------------

bool SaveSmosa(void)
{

FILE *out2;

bool Good;

int i, j, cnt;

char *datafile="*********************************";

char *variable="*********************************";

textcolor(10);

cprintf("  䠩   SMOSA C : ");

scanf("%s",datafile);

cprintf("  ६ SMOSA_FONT \n\r");

scanf("%s",variable);

out2=fopen(datafile,"wt");

Good=(out2!=NULL);

if (Good)

   {

   fprintf(out2, "//-- FontEd generated font code --\r\n"

                 "SMOSA_SYMBOL %s[]={ %ldL, %ldL\r\n",

                 variable,

                 (unsigned long)h, (unsigned long)w);

   cnt=0;

   for (i=0; i<256; i++)

      for (j=0; j<h; j++)

      {

      fprintf(out2,", 0x%lXL", font[i][j]);

      cnt++;

      if (cnt%5==0)

         fprintf(out2,"\r\n");

      }//end for-for

   if (cnt%5!=1) fprintf(out2,"\r\n");

   fprintf(out2,"}; //-- end of FontEd generated code --");

   fclose(out2);

   }//end if

return Good;

}//end SaveSmosa
//-----------------------------------------------------


bool SaveFont(char *_path)
{

FILE *out;

bool Good;

int i, j;

out=fopen(_path,"wt");

Good=(out!=NULL);

if (Good)

{

   fprintf(out,"%d\n%d\n",w,h);

   for (i=0; i<256; i++)

      for (j=0; j<h; j++) fprintf(out,"%lu\n",font[i][j]);

   fclose(out);

}//end if

return Good;

}//end SaveFont
//-----------------------------------------------------

bool LoadFont(char *_path)
{

FILE *in;

bool Good, Do=true;

int i, j;

unsigned long tempa;

in=fopen(_path,"rt");

Good=(in!=NULL);

if (Good)

{

   fscanf(in,"%d%d",&w,&h);

   Do=(feof(in)==0) && (ferror(in)==0) && (h>0) && (w>0);

   if (Do)

   {

      font=new unsigned long * [256];

      for (i=0; i<256; i++) font[i]=new unsigned long [h];

   }//end if

   else Good=false;

   for (i=0; (i<256) && Do; i++)

      for (j=0; (j<h) && Do; j++)

      {

         fscanf(in,"%lu",&tempa);

         font[i][j]=tempa;

         Do=(feof(in)==0) && (ferror(in)==0);

      }//end

   fclose(in);

}//end if

return Good;

}//end LoadFont
//-----------------------------------------------------

void DrawSymbInfo(int x, int y, int _smb)
{

char buffer[20];

bool valid;

valid = (_smb>=0) && (_smb<256);

settextjustify(LEFT_TEXT, TOP_TEXT);

settextstyle(0, 0, 1);

setcolor(15);

setfillstyle(1,0);

if (valid)

   sprintf(buffer, "DEC : %d", _smb);

else

   sprintf(buffer, "DEC : ");

bar(x, y, x+76, y+10);

outtextxy(x+2, y+2, buffer);

y += 12;

if (valid)

   sprintf(buffer, "HEX : %X", _smb);

else

   sprintf(buffer, "HEX : ");

bar(x, y, x+76, y+10);

outtextxy(x+2, y+2, buffer);

}//end DrawSymbInfo
//-----------------------------------------------------


int main(int argc, char *argv[])
{

int gd=VESA256, gm=RES800x600, ec;

int i=1, j=1, rgn=-1, oldrgn=0;

int chr=-1, oldchr=0;

char *fontpath, enterpath[256];

char fn_dr[_MAX_DRIVE], fn_dir[_MAX_DIR];

char fn_nm[_MAX_FNAME], fn_ext[_MAX_EXT];

bool Loop=true, Key=false;

if (argc>1)

{

   if (! LoadFont(argv[1])) return 1;

   fontpath=argv[1];

   _splitpath(fontpath, fn_dr, fn_dir,

      fn_nm, fn_ext);

   sprintf(fnt_file_name, "%s%s",

      fn_nm, fn_ext);

}

else

{

   textcolor(10);

   cprintf("FontEd "FVERSION);
   textcolor(2);
   cprintf(" P ⮢ MGI\n\r");
   textcolor(13);
   cprintf("Michael Graphics Interface (MGI)");
   textcolor(2);
   cprintf(",  . . \n\r");
   textcolor(15);
   cprintf("  "__DATE__".\n\r\n\r");

   cprintf("!    ন ० 800 x 600.\n\r");

   cprintf("᫨  ন,    ਭ = 0.\n\r\n\r");

   textcolor(9);

   cprintf("  : ");

   scanf("%d",&h);
   cprintf(" ਭ : ");
   scanf("%d",&w);

   textcolor(10);

   cprintf("  䠩 : ");

   scanf("%s",enterpath);

   fontpath=(char*)enterpath;

   font=new unsigned long * [256];

   for (i=0; i<256; i++) font[i]=new unsigned long [h];

   for (i=0; i<256; i++)

      for (j=0; j<h; j++) font[i][j]=0;

}//end else

if ((h<=0) || (w<=0) || (h>36) || (w>32))

   ec=-1;

else

{

   initgraph(&gd,&gm,"");

   ec=graphresult();

}

if (ec==grOk)

{

   dx=w + 17;

   dy=h + ((h>16)?1:3);

   if (h<8) dy += 8-h;

   Init();

   mouse.Init();

   mouse.SetCursor(0);

   DrawTable(true, i, j);

   while (Loop)

   {

      do

      {

         mouse.Show();

         delay(50);

         mouse.Ask();

          oldrgn = rgn;

          oldchr = chr;

          rgn=mouse.Find(&regions);

          chr=((mouse.Y()-y_begin)/dy)<<4;

          chr+=mouse.X()/dx;

         mouse.Hide();

         if ( (rgn!=oldrgn) ||

             (chr!=oldchr) )

         {

            if ((chr>=0) && (rgn==0))

               DrawSymbInfo(300, 570, chr);

            if (rgn!=0)

               DrawSymbInfo(300, 570, -1);

         }

         Key=(kbhit()!=0);

         if (Key) getch();

      } while (! mouse.LClick() || Key);

      switch (rgn)

      {

         case 0: if (chr>0)

                 {

                   EditSymbol(chr);

                   DrawTable(false, chr & 0xf, chr>>4);

                 }

                 break;

         case 1: Loop=false;

                 break;

         case 2: SaveFont(fontpath);

                 break;

         case 3: restorecrtmode();

                 SaveData();

                 setgraphmode(getgraphmode());

                 DrawTable(true, i, j);

                 break;

         case 4: restorecrtmode();

                 SaveSmosa();

                 setgraphmode(getgraphmode());

                 DrawTable(true, i, j);

                 break;

      }//end switch

   }//end while (Loop)

   SaveFont(fontpath);

   closegraph();

}//end if

for (i=0; i<256; i++) delete[] font[i];

delete[] font;

return 0;

}//end main
